searchNodes=[{"doc":"A simple way to sync between processes.","ref":"Trigger.html","title":"Trigger","type":"module"},{"doc":"Sends a new event with arbitrary data to the receiver. Examples iex&gt; trigger = Trigger . new ( ) % Trigger { ... } iex&gt; Trigger . fire ( trigger ) :ok iex&gt; Trigger . wait ( trigger ) { # PID &lt; 0 . 257 . 0 &gt; , nil }","ref":"Trigger.html#fire/2","title":"Trigger.fire/2","type":"function"},{"doc":"Sends a new event with arbitrary data to the receiver and waits for a reply. Examples iex&gt; trigger = Trigger . new ( ) % Trigger { ... } iex&gt; pid = spawn ( fn -&gt; ...&gt; &quot;Hello, world&quot; = Trigger . fire_wait ( trigger , &quot;world&quot; ) ...&gt; end ) # PID &lt; 0 . 262 . 0 &gt; iex&gt; { sender , name } = Trigger . wait ( trigger ) { # PID &lt; 0 . 262 . 0 &gt; , &quot;world&quot; } iex&gt; Process . alive? ( pid ) true iex&gt; Trigger . reply ( trigger , sender , &quot;Hello, \#{ name } &quot; ) :ok iex&gt; Process . alive? ( pid ) false","ref":"Trigger.html#fire_wait/3","title":"Trigger.fire_wait/3","type":"function"},{"doc":"Creates a new Trigger. Options receiver - configure an event receiver, defaults to self() Examples iex&gt; Trigger . new ( ) % Trigger { ... }","ref":"Trigger.html#new/1","title":"Trigger.new/1","type":"function"},{"doc":"Sends a reply back to the process which sent the event.","ref":"Trigger.html#reply/3","title":"Trigger.reply/3","type":"function"},{"doc":"Waits for an event. For examples see fire/2 or fire_wait/3 .","ref":"Trigger.html#wait/2","title":"Trigger.wait/2","type":"function"},{"doc":"Waits fot an event and sends a reply back right away. This is useful to have a two-way sync between processes, so event-sender knows that the receiver has got the event. Examples iex&gt; trigger = Trigger . new ( ) % Trigger { ... } iex&gt; test = fn -&gt; IO . inspect ( { self ( ) , :erlang . unique_integer ( [ :positive , :monotonic ] ) } ) ; :ok end # Function &lt; ... &gt; iex&gt; test . ( ) { # PID &lt; 0 . 247 . 0 &gt; , 1 } iex&gt; spawn ( fn -&gt; ...&gt; test . ( ) ...&gt; &quot;pong&quot; = Trigger . fire_wait ( trigger , &quot;ping&quot; ) ...&gt; test . ( ) ...&gt; end ) { # PID &lt; 0 . 258 . 0 &gt; , 2 } # PID &lt; 0 . 258 . 0 &gt; iex&gt; &quot;ping&quot; = Trigger . wait_reply ( trigger , &quot;pong&quot; ) ; test . ( ) { # PID &lt; 0 . 247 . 0 &gt; , 3 } { # PID &lt; 0 . 258 . 0 &gt; , 4 }","ref":"Trigger.html#wait_reply/3","title":"Trigger.wait_reply/3","type":"function"},{"doc":"A Trigger data type.","ref":"Trigger.html#t:t/0","title":"Trigger.t/0","type":"opaque"},{"doc":"A simple way to sync between processes. Especially useful when writing ExUnit tests.","ref":"readme.html","title":"Trigger","type":"extras"},{"doc":"The package can be installed by adding trigger to your list of dependencies in mix.exs : def deps do [ { :trigger , &quot;~&gt; 1.0&quot; } , ] end Documentation can be found at https://hexdocs.pm/trigger . Usage First, you need to create a trigger: iex(1)&gt; trigger = Trigger . new ( ) % Trigger { receiver : # PID &lt; 0 . 200 . 0 &gt; , ref : # Reference &lt; 0.602029420 . 2269642755.58891 &gt; } The trigger contains pid of a signal receiver and an unique reference. To fire the trigger (usually from another process): iex(2)&gt; spawn ( fn -&gt; Trigger . fire ( trigger , &quot;data&quot; ) end ) # PID &lt; 0 . 209 . 0 &gt; An arbitrary data can be sent with the trigger signal (default nil ). To wait until the trigger is fired: iex(3)&gt; { sender , data } = Trigger . wait ( trigger ) { # PID &lt; 0 . 209 . 0 &gt; , &quot;data&quot; } It is also possible to send arbitrary data back to trigger sender: iex(1)&gt; trigger = Trigger . new ( ) % Trigger { receiver : # PID &lt; 0 . 233 . 0 &gt; , ref : # Reference &lt; 0.785945778 . 3082813446.171011 &gt; } iex(2)&gt; spawn ( fn -&gt; ...(2)&gt; &quot;Hello, world&quot; = Trigger . fire_wait ( trigger , &quot;world&quot; ) ...(2)&gt; end ) # PID &lt; 0 . 238 . 0 &gt; iex(3)&gt; { sender , name } = Trigger . wait ( trigger ) { # PID &lt; 0 . 238 . 0 &gt; , &quot;world&quot; } iex(4)&gt; Trigger . reply ( trigger , sender , &quot;Hello, \#{ name } &quot; ) :ok In addition, a single trigger can be fired multiple times.","ref":"readme.html#installation","title":"Trigger - Installation","type":"extras"}]